/******************************************************************************
* Copyright (c) 2011, Linear Technology, Corp.                                *
* Linear Tech Proprietary and Confidential                                    *
*                                                                             *
* Title:                                                                      *
* Author:          Gary Yu                                                    *
* Create Date:     10:08:58 09/09/2011                                        *
* Design Name:                                                                *
* Module Name:                                                                *
* Project Name:                                                               *
* Target Devices:                                                             *
* Tool versions:                                                              *
* Description:                                                                *
*                                                                             *
* Dependencies:                                                               *
*                                                                             *
* Revision 1.0     10:08:58 09/09/2011 Gary Yu                                *
* File Created                                                                *
*                                                                             *
* Additional Comments:                                                        *
*                                                                             *
******************************************************************************/

`timescale 1ns / 1ps

module altbram_addr #
(
parameter   BRAM_ADDR_WIDTH = 17
)
(
addr_trigger, 
addr,

buf_mode,
cnt_done,
cnt_data,

BUFFER_ADDR_CNT,

rst);
 
input  addr_trigger; 

input        buf_mode;
input        cnt_data;
input        rst;

output [BRAM_ADDR_WIDTH - 1:0] addr;
output        cnt_done;

input [BRAM_ADDR_WIDTH - 4:0] BUFFER_ADDR_CNT;

reg [BRAM_ADDR_WIDTH - 1:0] addr;
reg cnt_done;
     
always @ (posedge addr_trigger)//gyu glitch
  if(~rst)
  begin
    addr          <= #1 {BRAM_ADDR_WIDTH{1'b0}};//try gyu
    cnt_done      <= #1 1'b0;
  end
  else if(cnt_data)
  begin
    if(buf_mode)//stop triggered by buffer is full
      if(addr == {BUFFER_ADDR_CNT, 3'b101})//gyu more 8
      begin
        cnt_done  <= #1 1'b1;
        addr      <= #1 addr + 1;
      end
      else if ((addr == {BUFFER_ADDR_CNT, 3'b110}) && cnt_done)
        addr      <= #1 addr + 1;
      else if ((addr == {BUFFER_ADDR_CNT, 3'b111}) && cnt_done)
        addr      <= #1 addr;
      else
        addr      <= #1 addr + 1;
    else//never stop except system reset
      if (addr == {BUFFER_ADDR_CNT, 3'b111})
        addr      <= #1 {BRAM_ADDR_WIDTH{1'b0}};
      else  
        addr      <= #1 addr + 1;
   end

       
endmodule
